#include "hardware.h"
#include "adc.h"

#define ADCR_CLKDIV						(10<<8)

void adc_init(void)
{
	// power-up ADC
	LPC_SYSCON->PDRUNCFG &= ~0x0010;
	LPC_SYSCON->SYSAHBCLKCTRL |= 0x2000;
	LPC_ADC->CR = ADCR_CLKDIV|0x01;

	//LPC_IOCON->R_PIO0_11 = 0x02;	// P0.11 <- AD0
	LPC_IOCON->R_PIO1_0 = 0x02;		// P1.0  <- AD1
	//LPC_IOCON->R_PIO1_1 = 0x02;		// P1.1  <- AD2
	LPC_IOCON->R_PIO1_2 = 0x02;		// P1.2  <- AD3
	LPC_IOCON->SWDIO_PIO1_3 = 0x02;	// P1.3	 <- AD4
	LPC_IOCON->PIO1_4 = 0x01;		// P1.4	 <- AD5
	//LPC_IOCON->PIO1_10 = 0x01;		// P1.10 <- AD6
	//LPC_IOCON->PIO1_11 = 0x01;		// P1.11 <- AD7}
}

int32_t adc_get(const uint8_t channel)
{
	uint32_t val;
	int32_t result = -1;

	// power-up ADC
	LPC_SYSCON->PDRUNCFG &= ~0x0010;

	LPC_ADC->CR = ADCR_CLKDIV|(1<<channel);

	// start conversion now
  	LPC_ADC->CR |= 0x01000000;
    while (((val=LPC_ADC->GDR) & 0x80000000)==0);
    // stop conversion
    LPC_ADC->CR &= ~0x01000000;
    if ((val & 0x40000000)==0) {
    	result = (val>>6) & 0x3ff;
    }
	LPC_ADC->CR = 0;

	return result;
}

