#include "hardware.h"
#include "gpio.h"
#include "uart.h"
#include "timer.h"
#include "adc.h"

void read_adc(int channel)
{
	int val;
	val = adc_get(channel);
	uart_send("AD");
	uart_send_int(channel);
	uart_send(": ");
	uart_send_int(val);
	uart_send("  ");
}

int main(void)
{
	LPC_GPIO0->DIR |= LED_1_PIN|LED_2_PIN;
	LPC_GPIO2->DIR |= 0x80;

	timer_init();
	uart_init();
	adc_init();

	while(1) {
		read_adc(1);
		read_adc(3);
		read_adc(4);
		read_adc(5);
		uart_send("\n");
		delay(10);
	}
	return 0;

}
